/* -*- C -*-
 * Spamtest connection library
 * File: mess822.h
 *      (C)  Alex Tutubalin <lexa@lexa.ru>
 *	Apr-May 2003
 *
 * Created: Wed Apr 23 22:08:08 2003
 */
#ifndef MESS822_H
#define MESS822_H

#include "heap.h"

typedef struct
{
    char *s;
    unsigned int len;
    unsigned int a;
//    msg_heap_t *store;
}stralloc;

int stralloc_cat(stralloc *sato,stralloc *safrom);
int stralloc_catb(stralloc *sa,char *s, unsigned int n);
int stralloc_cats(stralloc *sa, char *s);
int stralloc_copy(stralloc *sato,stralloc *safrom);
int stralloc_copyb(stralloc * sa, char *s, unsigned int n);
extern int stralloc_ready(stralloc *,unsigned int);
extern int stralloc_readyplus(stralloc *,unsigned int);
extern int stralloc_append(stralloc *,char*); /* beware: this takes a pointer to 1 char */
int stralloc_copyb(stralloc * sa, char *s, unsigned int n);
int stralloc_copys(stralloc *sa, char *s);

#define CLEAN_SA(sa)			\
do{					\
    if(sa.s){free(sa.s);sa.s=0;}	\
 if (sa.len)sa.len=0;			\
 if (sa.a)sa.a=0;			\
}while(0)


int mess822_token(stralloc *out, char* in);
int mess822_addrlist(stralloc *out,char *in);
int mess822_quoteplus(stralloc *out,char *addr,char *comment);
int mess822_quote(stralloc *out,char *addr,char *comment);
extern int mess822_quotelist();
int mess822_quotelist(stralloc *out,stralloc *in);

#endif
