/* -*- C -*-
 * Spamtest connection library
 * File: spamtest_internal.h
 *      (C)  Alex Tutubalin <lexa@lexa.ru>
 *	Apr-May 2003
 *
 * Created: Wed Apr 23 22:08:08 2003
 */
#ifndef __SPAMTEST_INTERNAL_H
#define __SPAMTEST_INTERNAL_H
#ifdef AP_BUILD
#include "smtp-filter/common/rec_types.h"
#else
#include "rec_types.h"
#endif

#include "heap.h"
#include "bufio.h"

#define TIMEOUT_QUANT 50
/* minimal timeout in ms */
#define MIN_TIMEOUT   1

message_status_t *make_new_status(spamtest_status_t *st);
int add_action(message_status_t *msg, msg_heap_t *heap, int type, char *hdr, char *val);
hdraction_t *make_new_action(message_status_t *ms,msg_heap_t *heap);
int msgstat_addbody(message_status_t *msg, msg_heap_t *heap, char *line, int len);
int calc_timeout(spamtest_session_t *s,int);
int check_init(spamtest_session_t *s);


#endif
